Manipulation of the Prediction Models

## Files

file | model.h
| The model details data structure and its corresponding modifiers.

## Data Structures

struct | vrna_md_s
| The data structure that contains the complete model details used throughout the calculations. More...

## Macros

#define | VRNA_MODEL_DEFAULT_TEMPERATURE 37.0
| Default temperature for structure prediction and free energy evaluation in °C More...
#define | VRNA_MODEL_DEFAULT_PF_SCALE -1
| Default scaling factor for partition function computations. More...
#define | VRNA_MODEL_DEFAULT_BETA_SCALE 1.
| Default scaling factor for absolute thermodynamic temperature in Boltzmann factors. More...
#define | VRNA_MODEL_DEFAULT_DANGLES 2
| Default dangling end model. More...
#define | VRNA_MODEL_DEFAULT_SPECIAL_HP 1
| Default model behavior for lookup of special tri-, tetra-, and hexa-loops. More...
#define | VRNA_MODEL_DEFAULT_NO_LP 0
| Default model behavior for so-called 'lonely pairs'. More...
#define | VRNA_MODEL_DEFAULT_NO_GU 0
| Default model behavior for G-U base pairs. More...
#define | VRNA_MODEL_DEFAULT_NO_GU_CLOSURE 0
| Default model behavior for G-U base pairs closing a loop. More...
#define | VRNA_MODEL_DEFAULT_CIRC 0
| Default model behavior to treat a molecule as a circular RNA (DNA) More...
#define | VRNA_MODEL_DEFAULT_GQUAD 0
| Default model behavior regarding the treatment of G-Quadruplexes. More...
#define | VRNA_MODEL_DEFAULT_UNIQ_ML 0
| Default behavior of the model regarding unique multibranch loop decomposition. More...
#define | VRNA_MODEL_DEFAULT_ENERGY_SET 0
| Default model behavior on which energy set to use. More...
#define | VRNA_MODEL_DEFAULT_BACKTRACK 1
| Default model behavior with regards to backtracking of structures. More...
#define | VRNA_MODEL_DEFAULT_BACKTRACK_TYPE 'F'
| Default model behavior on what type of backtracking to perform. More...
#define | VRNA_MODEL_DEFAULT_COMPUTE_BPP 1
| Default model behavior with regards to computing base pair probabilities. More...
#define | VRNA_MODEL_DEFAULT_MAX_BP_SPAN -1
| Default model behavior for the allowed maximum base pair span. More...
#define | VRNA_MODEL_DEFAULT_WINDOW_SIZE -1
| Default model behavior for the sliding window approach. More...
#define | VRNA_MODEL_DEFAULT_LOG_ML 0
| Default model behavior on how to evaluate the energy contribution of multibranch loops. More...
#define | VRNA_MODEL_DEFAULT_ALI_OLD_EN 0
| Default model behavior for consensus structure energy evaluation. More...
#define | VRNA_MODEL_DEFAULT_ALI_RIBO 0
| Default model behavior for consensus structure covariance contribution assessment. More...
#define | VRNA_MODEL_DEFAULT_ALI_CV_FACT 1.
| Default model behavior for weighting the covariance score in consensus structure prediction. More...
#define | VRNA_MODEL_DEFAULT_ALI_NC_FACT 1.
| Default model behavior for weighting the nucleotide conservation? in consensus structure prediction. More...
#define | MAXALPHA 20
| Maximal length of alphabet.

## Typedefs

typedef struct vrna_md_s | vrna_md_t
| Typename for the model details data structure vrna_md_s.

## Functions

void | vrna_md_set_default (vrna_md_t *md)
| Apply default model details to a provided vrna_md_t data structure. More...
void | vrna_md_update (vrna_md_t *md)
| Update the model details data structure. More...
char * | vrna_md_option_string (vrna_md_t *md)
| Get a corresponding commandline parameter string of the options in a vrna_md_t. More...
void | vrna_md_defaults_reset (vrna_md_t *md_p)
| Reset the global default model details to a specific set of parameters, or their initial values. More...
void | vrna_md_defaults_temperature (double T)
| Set default temperature for energy evaluation of loops. More...
double | vrna_md_defaults_temperature_get (void)
| Get default temperature for energy evaluation of loops. More...
void | vrna_md_defaults_betaScale (double b)
| Set default scaling factor of thermodynamic temperature in Boltzmann factors. More...
double | vrna_md_defaults_betaScale_get (void)
| Get default scaling factor of thermodynamic temperature in Boltzmann factors. More...
void | vrna_md_defaults_dangles (int d)
| Set default dangle model for structure prediction. More...
int | vrna_md_defaults_dangles_get (void)
| Get default dangle model for structure prediction. More...
void | vrna_md_defaults_special_hp (int flag)
| Set default behavior for lookup of tabulated free energies for special hairpin loops, such as Tri-, Tetra-, or Hexa-loops. More...
int | vrna_md_defaults_special_hp_get (void)
| Get default behavior for lookup of tabulated free energies for special hairpin loops, such as Tri-, Tetra-, or Hexa-loops. More...
void | vrna_md_defaults_noLP (int flag)
| Set default behavior for prediction of canonical secondary structures. More...
int | vrna_md_defaults_noLP_get (void)
| Get default behavior for prediction of canonical secondary structures. More...
void | vrna_md_defaults_noGU (int flag)
| Set default behavior for treatment of G-U wobble pairs. More...
int | vrna_md_defaults_noGU_get (void)
| Get default behavior for treatment of G-U wobble pairs. More...
void | vrna_md_defaults_noGUclosure (int flag)
| Set default behavior for G-U pairs as closing pair for loops. More...
int | vrna_md_defaults_noGUclosure_get (void)
| Get default behavior for G-U pairs as closing pair for loops. More...
void | vrna_md_defaults_logML (int flag)
| Set default behavior recomputing free energies of multibranch loops using a logarithmic model. More...
int | vrna_md_defaults_logML_get (void)
| Get default behavior recomputing free energies of multibranch loops using a logarithmic model. More...
void | vrna_md_defaults_circ (int flag)
| Set default behavior whether input sequences are circularized. More...
int | vrna_md_defaults_circ_get (void)
| Get default behavior whether input sequences are circularized. More...
void | vrna_md_defaults_gquad (int flag)
| Set default behavior for treatment of G-Quadruplexes. More...
int | vrna_md_defaults_gquad_get (void)
| Get default behavior for treatment of G-Quadruplexes. More...
void | vrna_md_defaults_uniq_ML (int flag)
| Set default behavior for creating additional matrix for unique multibranch loop prediction. More...
int | vrna_md_defaults_uniq_ML_get (void)
| Get default behavior for creating additional matrix for unique multibranch loop prediction. More...
void | vrna_md_defaults_energy_set (int e)
| Set default energy set. More...
int | vrna_md_defaults_energy_set_get (void)
| Get default energy set. More...
void | vrna_md_defaults_backtrack (int flag)
| Set default behavior for whether to backtrack secondary structures. More...
int | vrna_md_defaults_backtrack_get (void)
| Get default behavior for whether to backtrack secondary structures. More...
void | vrna_md_defaults_backtrack_type (char t)
| Set default backtrack type, i.e. which DP matrix is used. More...
char | vrna_md_defaults_backtrack_type_get (void)
| Get default backtrack type, i.e. which DP matrix is used. More...
void | vrna_md_defaults_compute_bpp (int flag)
| Set the default behavior for whether to compute base pair probabilities after partition function computation. More...
int | vrna_md_defaults_compute_bpp_get (void)
| Get the default behavior for whether to compute base pair probabilities after partition function computation. More...
void | vrna_md_defaults_max_bp_span (int span)
| Set default maximal base pair span. More...
int | vrna_md_defaults_max_bp_span_get (void)
| Get default maximal base pair span. More...
void | vrna_md_defaults_min_loop_size (int size)
| Set default minimal loop size. More...
int | vrna_md_defaults_min_loop_size_get (void)
| Get default minimal loop size. More...
void | vrna_md_defaults_window_size (int size)
| Set default window size for sliding window structure prediction approaches. More...
int | vrna_md_defaults_window_size_get (void)
| Get default window size for sliding window structure prediction approaches. More...
void | vrna_md_defaults_oldAliEn (int flag)
| Set default behavior for whether to use old energy model for comparative structure prediction. More...
int | vrna_md_defaults_oldAliEn_get (void)
| Get default behavior for whether to use old energy model for comparative structure prediction. More...
void | vrna_md_defaults_ribo (int flag)
| Set default behavior for whether to use Ribosum Scoring in comparative structure prediction. More...
int | vrna_md_defaults_ribo_get (void)
| Get default behavior for whether to use Ribosum Scoring in comparative structure prediction. More...
void | vrna_md_defaults_cv_fact (double factor)
| Set the default covariance scaling factor used in comparative structure prediction. More...
double | vrna_md_defaults_cv_fact_get (void)
| Get the default covariance scaling factor used in comparative structure prediction. More...
void | vrna_md_defaults_nc_fact (double factor)
double | vrna_md_defaults_nc_fact_get (void)
void | vrna_md_defaults_sfact (double factor)
| Set the default scaling factor used to avoid under-/overflows in partition function computation. More...
double | vrna_md_defaults_sfact_get (void)
| Get the default scaling factor used to avoid under-/overflows in partition function computation. More...
void | set_model_details (vrna_md_t *md)
| Set default model details. More...

## Variables

double | temperature
| Rescale energy parameters to a temperature in degC. More...
double | pf_scale
| A scaling factor used by pf_fold() to avoid overflows. More...
int | dangles
| Switch the energy model for dangling end contributions (0, 1, 2, 3) More...
int | tetra_loop
| Include special stabilizing energies for some tri-, tetra- and hexa-loops;. More...
int | noLonelyPairs
| Global switch to avoid/allow helices of length 1. More...
int | noGU
| Global switch to forbid/allow GU base pairs at all.
int | no_closingGU
| GU allowed only inside stacks if set to 1.
int | circ
| backward compatibility variable.. this does not effect anything
int | gquad
| Allow G-quadruplex formation.
int | canonicalBPonly
int | uniq_ML
| do ML decomposition uniquely (for subopt)
int | energy_set
| 0 = BP; 1=any mit GC; 2=any mit AU-parameter More...
int | do_backtrack
| do backtracking, i.e. compute secondary structures or base pair probabilities More...
char | backtrack_type
| A backtrack array marker for inverse_fold() More...
char * | nonstandards
| contains allowed non standard base pairs More...
int | max_bp_span
| Maximum allowed base pair span. More...
int | oldAliEn
| use old alifold energies (with gaps)
int | ribo
| use ribosum matrices
int | logML
| if nonzero use logarithmic ML energy in energy_of_struct

## Detailed Description

## Data Structure Documentation

struct vrna_md_s

The data structure that contains the complete model details used throughout the calculations.

For convenience reasons, we provide the type name vrna_md_t to address this data structure without the use of the struct keyword

See also
  vrna_md_set_default(), set_model_details(), vrna_md_update(), vrna_md_t

### Data Fields

double | temperature
| The temperature used to scale the thermodynamic parameters.
double | betaScale
| A scaling factor for the thermodynamic temperature of the Boltzmann factors.
int | dangles
| Specifies the dangle model used in any energy evaluation (0,1,2 or 3) More...
int | special_hp
| Include special hairpin contributions for tri, tetra and hexaloops.
int | noLP
| Only consider canonical structures, i.e. no 'lonely' base pairs.
int | noGU
| Do not allow GU pairs.
int | noGUclosure
| Do not allow loops to be closed by GU pair.
int | logML
| Use logarithmic scaling for multi loops.
int | circ
| Assume RNA to be circular instead of linear.
int | gquad
| Include G-quadruplexes in structure prediction.
int | canonicalBPonly
| remove non-canonical bp's from constraint structures
int | uniq_ML
| Flag to ensure unique multibranch loop decomposition during folding.
int | energy_set
| Specifies the energy set that defines set of compatible base pairs.
int | backtrack
| Specifies whether or not secondary structures should be backtraced.
char | backtrack_type
| Specifies in which matrix to backtrack.
int | compute_bpp
| Specifies whether or not backward recursions for base pair probability (bpp) computation will be performed.
char | nonstandards [33]
| contains allowed non standard bases
int | max_bp_span
| maximum allowed base pair span
int | min_loop_size
| Minimum size of hairpin loops. More...
int | window_size
| Size of the sliding window for locally optimal structure predition.
int | oldAliEn
| Use old alifold energy model.
int | ribo
| Use ribosum scoring table in alifold energy model.
double | cv_fact
| Covariance scaling factor for consensus structure prediction.
double | sfact
| Scaling factor for partition function scaling.
int | rtype [8]
| Reverse base pair type array.
short | alias [MAXALPHA+1]
| alias of an integer nucleotide representation
int | pair [MAXALPHA+1][MAXALPHA+1]
| Integer representation of a base pair.

#### Field Documentation

int vrna_md_s::dangles

Specifies the dangle model used in any energy evaluation (0,1,2 or 3)

If set to 0 no stabilizing energies are assigned to bases adjacent to helices in free ends and multiloops (so called dangling ends). Normally (dangles = 1) dangling end energies are assigned only to unpaired bases and a base cannot participate simultaneously in two dangling ends. In the partition function algorithm vrna_pf() these checks are neglected. To provide comparability between free energy minimization and partition function algorithms, the default setting is 2. This treatment of dangling ends gives more favorable energies to helices directly adjacent to one another, which can be beneficial since such helices often do engage in stabilizing interactions through co-axial stacking.
If set to 3 co-axial stacking is explicitly included for adjacent helices in mutli-loops. The option affects only mfe folding and energy evaluation (vrna_mfe() and vrna_eval_structure()), as well as suboptimal folding (vrna_subopt()) via re-evaluation of energies. Co-axial stacking with one intervening mismatch is not considered so far.

Note
  Some function do not implement all dangle model but only a subset of (0,1,2,3). In particular, partition function algorithms can only handle 0 and 2. Read the documentaion of the particular recurrences or energy evaluation function for information about the provided dangle model.

int vrna_md_s::min_loop_size

Minimum size of hairpin loops.

Note
  The default value for this field is TURN, however, it may be 0 in cofolding context.

## Macro Definition Documentation

#define VRNA_MODEL_DEFAULT_TEMPERATURE 37.0

`#include <ViennaRNA/model.h>`

Default temperature for structure prediction and free energy evaluation in °C

See also
  vrna_md_t.temperature, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_PF_SCALE -1

`#include <ViennaRNA/model.h>`

Default scaling factor for partition function computations.

See also
  vrna_exp_param_t.pf_scale, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_BETA_SCALE 1.

`#include <ViennaRNA/model.h>`

Default scaling factor for absolute thermodynamic temperature in Boltzmann factors.

See also
  vrna_exp_param_t.alpha, vrna_md_t.betaScale, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_DANGLES 2

`#include <ViennaRNA/model.h>`

Default dangling end model.

See also
  vrna_md_t.dangles, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_SPECIAL_HP 1

`#include <ViennaRNA/model.h>`

Default model behavior for lookup of special tri-, tetra-, and hexa-loops.

See also
  vrna_md_t.special_hp, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_NO_LP 0

`#include <ViennaRNA/model.h>`

Default model behavior for so-called 'lonely pairs'.

See also
  vrna_md_t.noLP, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_NO_GU 0

`#include <ViennaRNA/model.h>`

Default model behavior for G-U base pairs.

See also
  vrna_md_t.noGU, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_NO_GU_CLOSURE 0

`#include <ViennaRNA/model.h>`

Default model behavior for G-U base pairs closing a loop.

See also
  vrna_md_t.noGUclosure, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_CIRC 0

`#include <ViennaRNA/model.h>`

Default model behavior to treat a molecule as a circular RNA (DNA)

See also
  vrna_md_t.circ, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_GQUAD 0

`#include <ViennaRNA/model.h>`

Default model behavior regarding the treatment of G-Quadruplexes.

See also
  vrna_md_t.gquad, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_UNIQ_ML 0

`#include <ViennaRNA/model.h>`

Default behavior of the model regarding unique multibranch loop decomposition.

See also
  vrna_md_t.uniq_ML, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_ENERGY_SET 0

`#include <ViennaRNA/model.h>`

Default model behavior on which energy set to use.

See also
  vrna_md_t.energy_set, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_BACKTRACK 1

`#include <ViennaRNA/model.h>`

Default model behavior with regards to backtracking of structures.

See also
  vrna_md_t.backtrack, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_BACKTRACK_TYPE 'F'

`#include <ViennaRNA/model.h>`

Default model behavior on what type of backtracking to perform.

See also
  vrna_md_t.backtrack_type, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_COMPUTE_BPP 1

`#include <ViennaRNA/model.h>`

Default model behavior with regards to computing base pair probabilities.

See also
  vrna_md_t.compute_bpp, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_MAX_BP_SPAN -1

`#include <ViennaRNA/model.h>`

Default model behavior for the allowed maximum base pair span.

See also
  vrna_md_t.max_bp_span, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_WINDOW_SIZE -1

`#include <ViennaRNA/model.h>`

Default model behavior for the sliding window approach.

See also
  vrna_md_t.window_size, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_LOG_ML 0

`#include <ViennaRNA/model.h>`

Default model behavior on how to evaluate the energy contribution of multibranch loops.

See also
  vrna_md_t.logML, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_ALI_OLD_EN 0

`#include <ViennaRNA/model.h>`

Default model behavior for consensus structure energy evaluation.

See also
  vrna_md_t.oldAliEn, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_ALI_RIBO 0

`#include <ViennaRNA/model.h>`

Default model behavior for consensus structure covariance contribution assessment.

See also
  vrna_md_t.ribo, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_ALI_CV_FACT 1.

`#include <ViennaRNA/model.h>`

Default model behavior for weighting the covariance score in consensus structure prediction.

See also
  vrna_md_t.cv_fact, vrna_md_defaults_reset(), vrna_md_set_default()

#define VRNA_MODEL_DEFAULT_ALI_NC_FACT 1.

`#include <ViennaRNA/model.h>`

Default model behavior for weighting the nucleotide conservation? in consensus structure prediction.

See also
  #vrna_md_t.nc_fact, vrna_md_defaults_reset(), vrna_md_set_default()

## Function Documentation

void vrna_md_set_default | ( | vrna_md_t * | md | ) |

`#include <ViennaRNA/model.h>`

Apply default model details to a provided vrna_md_t data structure.

Use this function to initialize a vrna_md_t data structure with its default values

Parameters

  md | A pointer to the data structure that is about to be initialized

void vrna_md_update | ( | vrna_md_t * | md | ) |

`#include <ViennaRNA/model.h>`

Update the model details data structure.

This function should be called after changing the vrna_md_t.energy_set attribute since it re-initializes base pairing related arrays within the vrna_md_t data structure. In particular, vrna_md_t.pair, vrna_md_t.alias, and vrna_md_t.rtype are set to the values that correspond to the specified vrna_md_t.energy_set option

See also
  vrna_md_t, vrna_md_t.energy_set, vrna_md_t.pair, vrna_md_t.rtype, vrna_md_t.alias, vrna_md_set_default()

char* vrna_md_option_string | ( | vrna_md_t * | md | ) |

`#include <ViennaRNA/model.h>`

Get a corresponding commandline parameter string of the options in a vrna_md_t.

Note
  This function is not threadsafe!

void vrna_md_defaults_reset | ( | vrna_md_t * | md_p | ) |

`#include <ViennaRNA/model.h>`

Reset the global default model details to a specific set of parameters, or their initial values.

This function resets the global default model details to their initial values, i.e. as specified by the ViennaRNA Package release, upon passing NULL as argument. Alternatively it resets them according to a set of provided parameters.

Note
  The global default parameters affect all function calls of RNAlib where model details are not explicitely provided. Hence, any change of them is not considered threadsafe

Warning
  This function first resets the global default settings to factory defaults, and only then applies user provided settings (if any). User settings that do not meet specifications are skipped.

See also
  vrna_md_set_default(), vrna_md_t

Parameters

  md_p | A set of model details to use as global default (if NULL is passed, factory defaults are restored)

void vrna_md_defaults_temperature | ( | double | T | ) |

`#include <ViennaRNA/model.h>`

Set default temperature for energy evaluation of loops.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_TEMPERATURE

Parameters

  T | Temperature in centigrade

double vrna_md_defaults_temperature_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default temperature for energy evaluation of loops.

See also
  vrna_md_defaults_temperature(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_TEMPERATURE

Returns
  The global default settings for temperature in centigrade

void vrna_md_defaults_betaScale | ( | double | b | ) |

`#include <ViennaRNA/model.h>`

Set default scaling factor of thermodynamic temperature in Boltzmann factors.

Bolzmann factors are then computed as .

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_BETA_SCALE

Parameters

  b | The scaling factor, default is 1.0

double vrna_md_defaults_betaScale_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default scaling factor of thermodynamic temperature in Boltzmann factors.

See also
  vrna_md_defaults_betaScale(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_BETA_SCALE

Returns
  The global default thermodynamic temperature scaling factor

void vrna_md_defaults_dangles | ( | int | d | ) |

`#include <ViennaRNA/model.h>`

Set default dangle model for structure prediction.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_DANGLES

Parameters

  d | The dangle model

int vrna_md_defaults_dangles_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default dangle model for structure prediction.

See also
  vrna_md_defaults_dangles(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_DANGLES

Returns
  The global default settings for the dangle model

void vrna_md_defaults_special_hp | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for lookup of tabulated free energies for special hairpin loops, such as Tri-, Tetra-, or Hexa-loops.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_SPECIAL_HP

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_special_hp_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for lookup of tabulated free energies for special hairpin loops, such as Tri-, Tetra-, or Hexa-loops.

See also
  vrna_md_defaults_special_hp(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_SPECIAL_HP

Returns
  The global default settings for the treatment of special hairpin loops

void vrna_md_defaults_noLP | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for prediction of canonical secondary structures.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_NO_LP

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_noLP_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for prediction of canonical secondary structures.

See also
  vrna_md_defaults_noLP(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_NO_LP

Returns
  The global default settings for predicting canonical secondary structures

void vrna_md_defaults_noGU | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for treatment of G-U wobble pairs.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_NO_GU

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_noGU_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for treatment of G-U wobble pairs.

See also
  vrna_md_defaults_noGU(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_NO_GU

Returns
  The global default settings for treatment of G-U wobble pairs

void vrna_md_defaults_noGUclosure | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for G-U pairs as closing pair for loops.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_NO_GU_CLOSURE

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_noGUclosure_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for G-U pairs as closing pair for loops.

See also
  vrna_md_defaults_noGUclosure(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_NO_GU_CLOSURE

Returns
  The global default settings for treatment of G-U pairs closing a loop

void vrna_md_defaults_logML | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior recomputing free energies of multibranch loops using a logarithmic model.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_LOG_ML

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_logML_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior recomputing free energies of multibranch loops using a logarithmic model.

See also
  vrna_md_defaults_logML(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_LOG_ML

Returns
  The global default settings for logarithmic model in multibranch loop free energy evaluation

void vrna_md_defaults_circ | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior whether input sequences are circularized.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_CIRC

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_circ_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior whether input sequences are circularized.

See also
  vrna_md_defaults_circ(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_CIRC

Returns
  The global default settings for treating input sequences as circular

void vrna_md_defaults_gquad | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for treatment of G-Quadruplexes.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_GQUAD

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_gquad_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for treatment of G-Quadruplexes.

See also
  vrna_md_defaults_gquad(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_GQUAD

Returns
  The global default settings for treatment of G-Quadruplexes

void vrna_md_defaults_uniq_ML | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for creating additional matrix for unique multibranch loop prediction.

Note
  Activating this option usually results in higher memory consumption!

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_UNIQ_ML

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_uniq_ML_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for creating additional matrix for unique multibranch loop prediction.

See also
  vrna_md_defaults_uniq_ML(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_UNIQ_ML

Returns
  The global default settings for creating additional matrices for unique multibranch loop prediction

void vrna_md_defaults_energy_set | ( | int | e | ) |

`#include <ViennaRNA/model.h>`

Set default energy set.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ENERGY_SET

Parameters

  e | Energy set (0, 1, 2, 3)

int vrna_md_defaults_energy_set_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default energy set.

See also
  vrna_md_defaults_energy_set(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ENERGY_SET

Returns
  The global default settings for the energy set

void vrna_md_defaults_backtrack | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for whether to backtrack secondary structures.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_BACKTRACK

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_backtrack_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for whether to backtrack secondary structures.

See also
  vrna_md_defaults_backtrack(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_BACKTRACK

Returns
  The global default settings for backtracking structures

void vrna_md_defaults_backtrack_type | ( | char | t | ) |

`#include <ViennaRNA/model.h>`

Set default backtrack type, i.e. which DP matrix is used.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_BACKTRACK_TYPE

Parameters

  t | The type ('F', 'C', or 'M')

char vrna_md_defaults_backtrack_type_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default backtrack type, i.e. which DP matrix is used.

See also
  vrna_md_defaults_backtrack_type(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_BACKTRACK_TYPE

Returns
  The global default settings that specify which DP matrix is used for backtracking

void vrna_md_defaults_compute_bpp | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set the default behavior for whether to compute base pair probabilities after partition function computation.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_COMPUTE_BPP

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_compute_bpp_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get the default behavior for whether to compute base pair probabilities after partition function computation.

See also
  vrna_md_defaults_compute_bpp(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_COMPUTE_BPP

Returns
  The global default settings that specify whether base pair probabilities are computed together with partition function

void vrna_md_defaults_max_bp_span | ( | int | span | ) |

`#include <ViennaRNA/model.h>`

Set default maximal base pair span.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_MAX_BP_SPAN

Parameters

  span | Maximal base pair span

int vrna_md_defaults_max_bp_span_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default maximal base pair span.

See also
  vrna_md_defaults_max_bp_span(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_MAX_BP_SPAN

Returns
  The global default settings for maximum base pair span

void vrna_md_defaults_min_loop_size | ( | int | size | ) |

`#include <ViennaRNA/model.h>`

Set default minimal loop size.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, TURN

Parameters

  size | Minimal size, i.e. number of unpaired nucleotides for a hairpin loop

int vrna_md_defaults_min_loop_size_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default minimal loop size.

See also
  vrna_md_defaults_min_loop_size(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, TURN

Returns
  The global default settings for minimal size of hairpin loops

void vrna_md_defaults_window_size | ( | int | size | ) |

`#include <ViennaRNA/model.h>`

Set default window size for sliding window structure prediction approaches.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_WINDOW_SIZE

Parameters

  size | The size of the sliding window

int vrna_md_defaults_window_size_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default window size for sliding window structure prediction approaches.

See also
  vrna_md_defaults_window_size(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_WINDOW_SIZE

Returns
  The global default settings for the size of the sliding window

void vrna_md_defaults_oldAliEn | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for whether to use old energy model for comparative structure prediction.

Note
  This option is outdated. Activating the old energy model usually results in worse consensus structure predictions.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ALI_OLD_EN

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_oldAliEn_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for whether to use old energy model for comparative structure prediction.

See also
  vrna_md_defaults_oldAliEn(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ALI_OLD_EN

Returns
  The global default settings for using old energy model for comparative structure prediction

void vrna_md_defaults_ribo | ( | int | flag | ) |

`#include <ViennaRNA/model.h>`

Set default behavior for whether to use Ribosum Scoring in comparative structure prediction.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ALI_RIBO

Parameters

  flag | On/Off switch (0 = OFF, else = ON)

int vrna_md_defaults_ribo_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get default behavior for whether to use Ribosum Scoring in comparative structure prediction.

See also
  vrna_md_defaults_ribo(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ALI_RIBO

Returns
  The global default settings for using Ribosum scoring in comparative structure prediction

void vrna_md_defaults_cv_fact | ( | double | factor | ) |

`#include <ViennaRNA/model.h>`

Set the default covariance scaling factor used in comparative structure prediction.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ALI_CV_FACT

Parameters

  factor | The covariance factor

double vrna_md_defaults_cv_fact_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get the default covariance scaling factor used in comparative structure prediction.

See also
  vrna_md_defaults_cv_fact(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ALI_CV_FACT

Returns
  The global default settings for the covariance factor

void vrna_md_defaults_nc_fact | ( | double | factor | ) |

`#include <ViennaRNA/model.h>`

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ALI_NC_FACT

Parameters

  factor |

double vrna_md_defaults_nc_fact_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

See also
  vrna_md_defaults_nc_fact(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t, VRNA_MODEL_DEFAULT_ALI_NC_FACT

Returns

void vrna_md_defaults_sfact | ( | double | factor | ) |

`#include <ViennaRNA/model.h>`

Set the default scaling factor used to avoid under-/overflows in partition function computation.

See also
  vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t

Parameters

  factor | The scaling factor (default: 1.07)

double vrna_md_defaults_sfact_get | ( | void |  | ) |

`#include <ViennaRNA/model.h>`

Get the default scaling factor used to avoid under-/overflows in partition function computation.

See also
  vrna_md_defaults_sfact(), vrna_md_defaults_reset(), vrna_md_set_default(), vrna_md_t

Returns
  The global default settings of the scaling factor

void set_model_details | ( | vrna_md_t * | md | ) |

`#include <ViennaRNA/model.h>`

Set default model details.

Use this function if you wish to initialize a vrna_md_t data structure with its default values, i.e. the global model settings as provided by the deprecated global variables.

Deprecated:
  This function will vanish as soon as backward compatibility of RNAlib is dropped (expected in version 3). Use vrna_md_set_default() instead!

Parameters

  md | A pointer to the data structure that is about to be initialized

## Variable Documentation

double temperature

`#include <ViennaRNA/model.h>`

Rescale energy parameters to a temperature in degC.

Default is 37C. You have to call the update_..._params() functions after changing this parameter.

Deprecated:
  Use vrna_md_defaults_temperature(), and vrna_md_defaults_temperature_get() to change, and read the global default temperature settings
  See also
    vrna_md_defaults_temperature(), vrna_md_defaults_temperature_get(), vrna_md_defaults_reset()

double pf_scale

`#include <ViennaRNA/model.h>`

A scaling factor used by pf_fold() to avoid overflows.

Should be set to approximately , where is an estimate for the ensemble free energy, for example the minimum free energy. You must call update_pf_params() after changing this parameter.
If pf_scale is -1 (the default) , an estimate will be provided automatically when computing partition functions, e.g. pf_fold() The automatic estimate is usually insufficient for sequences more than a few hundred bases long.

int dangles

`#include <ViennaRNA/model.h>`

Switch the energy model for dangling end contributions (0, 1, 2, 3)

If set to 0 no stabilizing energies are assigned to bases adjacent to helices in free ends and multiloops (so called dangling ends). Normally (dangles = 1) dangling end energies are assigned only to unpaired bases and a base cannot participate simultaneously in two dangling ends. In the partition function algorithm pf_fold() these checks are neglected. If dangles is set to 2, all folding routines will follow this convention. This treatment of dangling ends gives more favorable energies to helices directly adjacent to one another, which can be beneficial since such helices often do engage in stabilizing interactions through co-axial stacking.
If dangles = 3 co-axial stacking is explicitly included for adjacent helices in mutli-loops. The option affects only mfe folding and energy evaluation (fold() and energy_of_structure()), as well as suboptimal folding (subopt()) via re-evaluation of energies. Co-axial stacking with one intervening mismatch is not considered so far.

Default is 2 in most algorithms, partition function algorithms can only handle 0 and 2

int tetra_loop

`#include <ViennaRNA/model.h>`

Include special stabilizing energies for some tri-, tetra- and hexa-loops;.

default is 1.

int noLonelyPairs

`#include <ViennaRNA/model.h>`

Global switch to avoid/allow helices of length 1.

Disallow all pairs which can only occur as lonely pairs (i.e. as helix of length 1). This avoids lonely base pairs in the predicted structures in most cases.

int canonicalBPonly

`#include <ViennaRNA/model.h>`

Do not use this variable, it will eventually be removed in one of the next versions

int energy_set

`#include <ViennaRNA/model.h>`

0 = BP; 1=any mit GC; 2=any mit AU-parameter

If set to 1 or 2: fold sequences from an artificial alphabet ABCD..., where A pairs B, C pairs D, etc. using either GC (1) or AU parameters (2); default is 0, you probably don't want to change it.

int do_backtrack

`#include <ViennaRNA/model.h>`

do backtracking, i.e. compute secondary structures or base pair probabilities

If 0, do not calculate pair probabilities in pf_fold(); this is about twice as fast. Default is 1.

char backtrack_type

`#include <ViennaRNA/model.h>`

A backtrack array marker for inverse_fold()

If set to 'C': force (1,N) to be paired, 'M' fold as if the sequence were inside a multi-loop. Otherwise ('F') the usual mfe structure is computed.

char* nonstandards

`#include <ViennaRNA/model.h>`

contains allowed non standard base pairs

Lists additional base pairs that will be allowed to form in addition to GC, CG, AU, UA, GU and UG. Nonstandard base pairs are given a stacking energy of 0.

int max_bp_span

`#include <ViennaRNA/model.h>`

Maximum allowed base pair span.

A value of -1 indicates no restriction for distant base pairs.